// ==================================================
// Main code
// Code by faceH0r 12.05.2005
// ==================================================

#pragma comment(lib,"opengl32.lib")
#pragma comment(lib,"glu32.lib")
#pragma comment(lib,"glaux.lib")

#pragma comment(lib,"winmm.lib")

#pragma comment(lib,"openal32.lib")
#pragma comment(lib,"alut.lib")

// ==================================================
// Includes
// ==================================================

#include "ark_Heads.h"

// ==================================================
// Heads bricks
// ==================================================

	void brick_AddBrick(float x,float y,int health,int type);
	void brick_RenderBricks();
	void brick_SetVelocityOffset(int nmb,float vox,float voy);
	void brick_SetRandomVelocity();
	void brick_MoveBricks();
	void brick_DelBrick(int nmb);
	int brick_GetObjectByLine(int nmb);

// ==================================================
// Heads textures
// ==================================================

	void texture_AddTexture(char *fname);
	void texture_CallTexture(int nmb);

// ==================================================
// Heads animation
// ==================================================

	void animation_AddAnimation(int nmb,int count,float btime,float x,float y,float width,float height,int aplay,int aone);
	void animation_DelAnimation(int nmb);
	void animation_RenderAnimation();
	void animation_UpdateAnimation();

// ==================================================
// Heads lines
// ==================================================

	void line_AddLine(float x1,float y1,float x2,float y2);
	void line_RenderLines();

// ==================================================
// Heads spheres
// ==================================================

	void sphere_AddSphere(float x,float y,float angle,float velocity,float aox,float aoy);
	void sphere_UpdateSpheres();
	void sphere_CalculatePoints();

// ==================================================
// Heads platforms
// ==================================================

	void platform_AddPlatform(float x,float y,float width,float height,float aox,float aoy);
	void platform_UpdatePlatforms();
	void platform_SetPosition(int nmb,float x,float y);

// ==================================================
// Head particles
// ==================================================

	void particle_AddSystem(int count,float time,float x,float y,float r,float g,float b);
	void particle_UpdateParticles();
	void particle_RenderParticles();

// ==================================================
// Head bonuses
// ==================================================

	void bonus_DeleteBonus(int nmb);

// ==================================================
// Other heads
// ==================================================

	bool CrossLines(S_ARK_LINE_2D ln1,S_ARK_LINE_2D ln2,S_ARK_POINT_2D &pnt);
	void ArkPrintf(int nmb,float xf,float yf,char *str,...);
	void TestObjectLines(S_ARK_SPHERE_2D &obj);
	void LoadLevel(char *fname);
	void NewGame();
	void SaveScores();

/*
 ====================================================
 // Variables
 ====================================================
*/ 

	S_ARK_ANIMATION_2D g_Anim[ARK_MAX_ANIMATIONS];
	int c_Anims=0;

	S_ARK_LINE_2D g_Line[ARK_MAX_LINES];
	int c_Lines=0;

	S_ARK_BRICK_2D g_Brick[ARK_MAX_BRICKS];
	int c_Bricks=0;

	unsigned int g_Texture[ARK_MAX_TEXTURES];
	int c_Texture=0;

	S_ARK_SPHERE_2D g_Sphere[ARK_MAX_SPHERES];
	int c_Spheres=0;

	S_ARK_PLATFORM_2D g_Platform[ARK_MAX_PLATFORMS];
	int c_Platforms=0;

	S_ARK_PARTICLE_2D g_Particle[ARK_MAX_PARTICLES];
	int c_Particles=0;

	S_ARK_ITEM_2D g_Item[ARK_MAX_ITEMS];
	int c_Items=0;

	S_ARK_BONUS_2D g_Bonus[ARK_MAX_BONUSES];
	int c_Bonuses=0;

	char g_LevelName[ARK_MAX_LEVELS][256];
	int c_Levels=0;

	S_ARK_GAME m_Game;

	ALuint g_Buffer[ARK_MAX_SOUND_BUFFERS];
	ALuint g_BSource[ARK_MAX_SOUND_BUFFERS];
	int c_Buffers=0;
	int c_Fonts=0;

/*
 ====================================================
 // Textures
 ====================================================
*/

void texture_AddTexture(char *fname){
	AUX_RGBImageRec *i_Image=auxDIBImageLoad(fname);
	char *data;
	int i,j;
	//
	int SX,SY;
	//

	c_Texture++;

	SX=i_Image->sizeX;
	SY=i_Image->sizeY;

	data=new char[SX*SY*4];

	for(j=0;j<SY;j++)
		for(i=0;i<SX;i++){
			data[(j*SX+i)*4]=i_Image->data[(j*SX+i)*3];
			data[(j*SX+i)*4+1]=i_Image->data[(j*SX+i)*3+1];
			data[(j*SX+i)*4+2]=i_Image->data[(j*SX+i)*3+2];
			//

			if(i_Image->data[(j*SX+i)*3]==0&&
			   i_Image->data[(j*SX+i)*3+1]==0&&
			   i_Image->data[(j*SX+i)*3+2]==0)
					data[(j*SX+i)*4+3]=0;
			else
				data[(j*SX+i)*4+3]=255;
		}

	glGenTextures(1,&g_Texture[c_Texture]);
	glBindTexture(GL_TEXTURE_2D,g_Texture[c_Texture]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA,i_Image->sizeX,i_Image->sizeY,GL_RGBA,GL_UNSIGNED_BYTE,data);
}

// ==================================================

void texture_CallTexture(int nmb){
	glBindTexture(GL_TEXTURE_2D,g_Texture[nmb]);
}

// ==================================================

/*
 ====================================================
 // Animation
 ====================================================
*/

void animation_AddAnimation(int nmb,int count,float btime,float x,float y,float width,float height,int aplay,int aone){
	g_Anim[c_Anims].nmb_Texture=nmb;
	g_Anim[c_Anims].c_Frames=count;
	g_Anim[c_Anims].t_BFrames=btime;
	g_Anim[c_Anims].x=x;
	g_Anim[c_Anims].y=y;
	g_Anim[c_Anims].width=width;
	g_Anim[c_Anims].height=height;
	g_Anim[c_Anims].a_Play=aplay;
	g_Anim[c_Anims].a_One=aone;

	c_Anims++;
}

// ==================================================

void animation_UpdateAnimation(){
	for(int i=0;i<c_Anims;i++){
		if(g_Anim[i].a_Play){
			g_Anim[i].t_CFrame+=10*m_Game.d_Time;
		
			if(g_Anim[i].t_CFrame>=g_Anim[i].t_BFrames){
				g_Anim[i].t_CFrame=0;
				g_Anim[i].c_Frame++;
			}

			if(g_Anim[i].c_Frame>=g_Anim[i].c_Frames){
				g_Anim[i].c_Frame=0;
				if(g_Anim[i].a_One)
					animation_DelAnimation(i);
			}
		}
	}
}

// ==================================================

void animation_RenderAnimation(){
	for(int i=0;i<c_Anims;i++){
		texture_CallTexture(g_Anim[i].nmb_Texture);
		glBegin(GL_QUADS);
			glTexCoord2d(0+1.0/g_Anim[i].c_Frames*g_Anim[i].c_Frame,0);
			glVertex2f(g_Anim[i].o_x+g_Anim[i].x-g_Anim[i].width/2,
				       g_Anim[i].o_y+g_Anim[i].y-g_Anim[i].height/2);

			glTexCoord2d(0+1.0/g_Anim[i].c_Frames*g_Anim[i].c_Frame,1);
			glVertex2f(g_Anim[i].o_x+g_Anim[i].x-g_Anim[i].width/2,
				       g_Anim[i].o_y+g_Anim[i].y+g_Anim[i].height/2);

			glTexCoord2d(1.0/g_Anim[i].c_Frames+1.0/g_Anim[i].c_Frames*g_Anim[i].c_Frame,1);
			glVertex2f(g_Anim[i].o_x+g_Anim[i].x+g_Anim[i].width/2,
				       g_Anim[i].o_y+g_Anim[i].y+g_Anim[i].height/2);

			glTexCoord2d(1.0/g_Anim[i].c_Frames+1.0/g_Anim[i].c_Frames*g_Anim[i].c_Frame,0);
			glVertex2f(g_Anim[i].o_x+g_Anim[i].x+g_Anim[i].width/2,
				       g_Anim[i].o_y+g_Anim[i].y-g_Anim[i].height/2);
		glEnd();
	}
}

// ==================================================

void animation_DelAnimation(int nmb){
	for(int i=nmb;i<c_Anims;i++){
		g_Anim[i]=g_Anim[i+1];
	}

	c_Anims--;
}

// ==================================================

/*
 ====================================================
 // Bricks
 ====================================================
*/

// ==================================================

void brick_AddBrick(float x,float y,int health,int type){
	g_Brick[c_Bricks].x=x;
	g_Brick[c_Bricks].y=y;
	g_Brick[c_Bricks].health=health;
	g_Brick[c_Bricks].type=type;

	for(int i=0;i<4;i++)
		g_Brick[c_Bricks].l_nmb[i]=c_Bricks*4+i;	
	
	g_Line[c_Lines].x1=g_Brick[c_Bricks].x-0.085;
	g_Line[c_Lines].y1=g_Brick[c_Bricks].y+0.035;
	g_Line[c_Lines].x2=g_Brick[c_Bricks].x-0.085;
	g_Line[c_Lines].y2=g_Brick[c_Bricks].y-0.035;

	g_Line[c_Lines+1].x1=g_Brick[c_Bricks].x+0.085;
	g_Line[c_Lines+1].y1=g_Brick[c_Bricks].y-0.035;
	g_Line[c_Lines+1].x2=g_Brick[c_Bricks].x+0.085;
	g_Line[c_Lines+1].y2=g_Brick[c_Bricks].y+0.035;

	g_Line[c_Lines+2].x1=g_Brick[c_Bricks].x-0.085;
	g_Line[c_Lines+2].y1=g_Brick[c_Bricks].y+0.035;
	g_Line[c_Lines+2].x2=g_Brick[c_Bricks].x+0.085;
	g_Line[c_Lines+2].y2=g_Brick[c_Bricks].y+0.035;

	g_Line[c_Lines+3].x1=g_Brick[c_Bricks].x+0.085;
	g_Line[c_Lines+3].y1=g_Brick[c_Bricks].y-0.035;
	g_Line[c_Lines+3].x2=g_Brick[c_Bricks].x-0.085;
	g_Line[c_Lines+3].y2=g_Brick[c_Bricks].y-0.035;

	g_Brick[c_Bricks].a_nmb=c_Anims;

	switch(type){
	case 0:
		animation_AddAnimation(3,1,0,x,y,0.18,0.08,false,true);
		break;
	case 1:
		animation_AddAnimation(4,3,0,x,y,0.18,0.08,false,true);
		break;
	case 2:
		animation_AddAnimation(5,1,0,x,y,0.18,0.08,false,true);
		break;
	}
	

	c_Bricks++;
	c_Lines+=4;
}

// ==================================================

void brick_SetVelocityOffset(int nmb,float vox,float voy){
	g_Brick[nmb].vo_x=vox;
	g_Brick[nmb].vo_y=voy;
}

// ==================================================

void brick_SetRandomVelocity(){
	for(int k=0;k<c_Bricks;k++)
		brick_SetVelocityOffset(k,sin(rand()/1000),cos(rand()/1000));
}

// ==================================================

void brick_MoveBricks(){
	int i,j;

	for(i=0;i<c_Bricks;i++){
		g_Brick[i].o_x+=(g_Brick[i].vo_x*m_Game.d_Time)*0.01;
		g_Brick[i].o_y+=(g_Brick[i].vo_y*m_Game.d_Time)*0.01;

		if(g_Brick[i].o_x>0.005){
			g_Brick[i].o_x=0.005;
			g_Brick[i].vo_x*=-1;
		}

		if(g_Brick[i].o_x<-0.005){
			g_Brick[i].o_x=-0.005;
			g_Brick[i].vo_x*=-1;
		}

		if(g_Brick[i].o_y>0.005){
			g_Brick[i].o_y=0.005;
			g_Brick[i].vo_y*=-1;
		}

		if(g_Brick[i].o_y<-0.005){
			g_Brick[i].o_y=-0.005;
			g_Brick[i].vo_y*=-1;
		}

		g_Anim[g_Brick[i].a_nmb].o_x=(g_Brick[i].o_x);
		g_Anim[g_Brick[i].a_nmb].o_y=(g_Brick[i].o_y);

		/*for(j=0;j<4;j++){
			g_Line[g_Brick[i].l_nmb[j]].x1+=g_Brick[i].vo_x*0.001;
			g_Line[g_Brick[i].l_nmb[j]].x2+=g_Brick[i].vo_x*0.001;
			g_Line[g_Brick[i].l_nmb[j]].y1+=g_Brick[i].vo_y*0.001;
			g_Line[g_Brick[i].l_nmb[j]].y2+=g_Brick[i].vo_y*0.001;
		}*/
	}
}

// ==================================================

void brick_DelBrick(int nmb){
	int i,j;

	animation_DelAnimation(g_Brick[nmb].a_nmb);

	for(i=nmb;i<c_Bricks;i++)
		g_Brick[i]=g_Brick[i+1];
	
	for(i=nmb*4;i<c_Lines;i++)
		g_Line[i]=g_Line[i+4];

	// Numbers reload!!! IMPORTANT!!!

	// Lines numbers

	for(i=nmb;i<c_Bricks;i++)
		for(j=0;j<4;j++)
			g_Brick[i].l_nmb[j]-=4;

	for(j=0;j<5;j++)
		g_Platform[0].l_nmb[j]-=4;

	// Animations reload

	for(i=0;i<c_Spheres;i++)
		g_Sphere[i].nmb_Anim--;
	
	for(i=0;i<c_Platforms;i++)
		g_Platform[i].a_nmb--;

	for(i=nmb;i<c_Bricks;i++)
		g_Brick[i].a_nmb--;

	c_Bricks--;
	c_Lines-=4;
}

// ==================================================

int brick_GetObjectByLine(int nmb){
	for(int i=0;i<c_Bricks;i++)
		if(g_Brick[i].l_nmb[0]==nmb||
		   g_Brick[i].l_nmb[1]==nmb||
		   g_Brick[i].l_nmb[2]==nmb||
		   g_Brick[i].l_nmb[3]==nmb)return i;

	return -1;
}

// ==================================================

/*
 ====================================================
 // Spheres
 ====================================================
*/

void sphere_AddSphere(float x,float y,float angle,float velocity,float aox,float aoy){
	g_Sphere[c_Spheres].x=x;
	g_Sphere[c_Spheres].y=y;
	g_Sphere[c_Spheres].vx=cos(angle)*0.01;
	g_Sphere[c_Spheres].vy=sin(angle)*0.01;
	g_Sphere[c_Spheres].velocity=velocity;
	g_Sphere[c_Spheres].a_ox=aox;
	g_Sphere[c_Spheres].a_oy=aoy;

	g_Sphere[c_Spheres].nmb_Anim=c_Anims;
	animation_AddAnimation(2,24,1,0,0,0.085,0.085,1,0);

	c_Spheres++;
}

// ==================================================

void sphere_CalculatePoints(){
	for(int j=0;j<c_Spheres;j++){
		for(int i=0;i<8;i++){
			g_Sphere[j].p[i].x=g_Sphere[j].x+sin((i*3.1415926*2)/8)*0.03;
			g_Sphere[j].p[i].y=g_Sphere[j].y+cos((i*3.1415925*2)/8)*0.03;
		}
	}
}

// ==================================================

void sphere_UpdateSpheres(){
	for(int i=0;i<c_Spheres;i++){
		sphere_CalculatePoints();

		g_Anim[g_Sphere[i].nmb_Anim].x=g_Sphere[i].x+g_Sphere[i].a_ox;
		g_Anim[g_Sphere[i].nmb_Anim].y=g_Sphere[i].y+g_Sphere[i].a_oy;
	}
}

// ==================================================

/*
 ====================================================
 // Lines
 ====================================================
*/

void line_AddLine(float x1,float y1,float x2,float y2){
	g_Line[c_Lines].x1=x1;
	g_Line[c_Lines].y1=y1;
	g_Line[c_Lines].x2=x2;
	g_Line[c_Lines].y2=y2;

	c_Lines++;
}

// ==================================================

void line_RenderLines(){
	glBegin(GL_LINES);
		for(int i=0;i<c_Lines;i++){
			glVertex2f(g_Line[i].x1,g_Line[i].y1);
			glVertex2f(g_Line[i].x2,g_Line[i].y2);
		}
	glEnd();
}

// ==================================================

void line_CalculateNormals(){
	float l_line;
	float d_x,d_y;

	for(int i=0;i<c_Lines;i++){
		d_x=g_Line[i].x2-g_Line[i].x1;
		d_y=g_Line[i].y2-g_Line[i].y1;

		l_line=sqrt(d_x*d_x+d_y*d_y);

		g_Line[i].ny=(float)(d_x/l_line);
		g_Line[i].nx=(float)(d_y/l_line);
	}
}

// ==================================================

/*
 ====================================================
 // Platforms
 ====================================================
*/

void platform_AddPlatform(float x,float y,float width,float height,float aox,float aoy){
	g_Platform[c_Platforms].x=x;
	g_Platform[c_Platforms].y=y;
	g_Platform[c_Platforms].width=width;
	g_Platform[c_Platforms].height=height;
	g_Platform[c_Platforms].a_ox=aox;
	g_Platform[c_Platforms].a_oy=aoy;

	for(int i=0;i<5;i++)
		g_Platform[c_Platforms].l_nmb[i]=c_Lines+i;

	g_Line[c_Lines].x1=x-0.05;
	g_Line[c_Lines].x2=x+0.05;
	g_Line[c_Lines].y1=y;
	g_Line[c_Lines].y2=y;

	g_Line[c_Lines+1].x1=x-0.05;
	g_Line[c_Lines+1].x2=x-0.1;
	g_Line[c_Lines+1].y1=y;
	g_Line[c_Lines+1].y2=y-0.05;

	g_Line[c_Lines+2].x1=x+0.05;
	g_Line[c_Lines+2].x2=x+0.1;
	g_Line[c_Lines+2].y1=y;
	g_Line[c_Lines+2].y2=y-0.05;

	g_Line[c_Lines+3].x1=x+0.1;
	g_Line[c_Lines+3].x2=x+0.15;
	g_Line[c_Lines+3].y1=y-0.05;
	g_Line[c_Lines+3].y2=y-0.15;

	g_Line[c_Lines+4].x1=x-0.1;
	g_Line[c_Lines+4].x2=x-0.15;
	g_Line[c_Lines+4].y1=y-0.05;
	g_Line[c_Lines+4].y2=y-0.15;

	g_Platform[c_Platforms].a_nmb=c_Anims;
	animation_AddAnimation(1,5,1,0,0,0.35,0.25,false,false);

	c_Platforms++;
	c_Lines++;
}

// ==================================================

void platform_SetPosition(int nmb,float x,float y){
	g_Platform[nmb].x=x;
	g_Platform[nmb].y=y;

	g_Line[g_Platform[nmb].l_nmb[0]].x1=g_Platform[nmb].x-0.15;
	g_Line[g_Platform[nmb].l_nmb[0]].x2=g_Platform[nmb].x+0.15;
	g_Line[g_Platform[nmb].l_nmb[0]].y1=g_Platform[nmb].y-0.05;
	g_Line[g_Platform[nmb].l_nmb[0]].y2=g_Platform[nmb].y-0.05;

/*	g_Line[g_Platform[nmb].l_nmb[1]].x1=g_Platform[nmb].x-0.1;
	g_Line[g_Platform[nmb].l_nmb[1]].x2=g_Platform[nmb].x-0.125;
	g_Line[g_Platform[nmb].l_nmb[1]].y1=g_Platform[nmb].y-0.04;
	g_Line[g_Platform[nmb].l_nmb[1]].y2=g_Platform[nmb].y-0.05;

	g_Line[g_Platform[nmb].l_nmb[2]].x1=g_Platform[nmb].x+0.05;
	g_Line[g_Platform[nmb].l_nmb[2]].x2=g_Platform[nmb].x+0.1;
	g_Line[g_Platform[nmb].l_nmb[2]].y1=g_Platform[nmb].y;
	g_Line[g_Platform[nmb].l_nmb[2]].y2=g_Platform[nmb].y-0.05;

	g_Line[g_Platform[nmb].l_nmb[3]].x1=g_Platform[nmb].x+0.1;
	g_Line[g_Platform[nmb].l_nmb[3]].x2=g_Platform[nmb].x+0.15;
	g_Line[g_Platform[nmb].l_nmb[3]].y1=g_Platform[nmb].y-0.05;
	g_Line[g_Platform[nmb].l_nmb[3]].y2=g_Platform[nmb].y-0.15;

	g_Line[g_Platform[nmb].l_nmb[4]].x1=g_Platform[nmb].x-0.1;
	g_Line[g_Platform[nmb].l_nmb[4]].x2=g_Platform[nmb].x-0.15;
	g_Line[g_Platform[nmb].l_nmb[4]].y1=g_Platform[nmb].y-0.05;
	g_Line[g_Platform[nmb].l_nmb[4]].y2=g_Platform[nmb].y-0.15;*/
}

// ==================================================

void platform_UpdatePlatforms(){
	float c_pos;

	for(int i=0;i<c_Platforms;i++){
		if(m_Game.g_Menu==false)
			c_pos=(float)(m_Game.g_Mpos.x-m_Game.dm.dmPelsWidth/2.0f)/((m_Game.dm.dmPelsWidth/2.0f)*1.17f);
		else 
			c_pos=(float)(m_Game.m_Mpos.x-m_Game.dm.dmPelsWidth/2.0f)/((m_Game.dm.dmPelsWidth/2.0f)*1.17f);

		platform_SetPosition(0,c_pos,-0.85);

		g_Anim[g_Platform[i].a_nmb].c_Frame=2;
		if((g_Platform[i].o_mx-c_pos)>0.005)g_Anim[g_Platform[i].a_nmb].c_Frame=1;
		if((g_Platform[i].o_mx-c_pos)<-0.005)g_Anim[g_Platform[i].a_nmb].c_Frame=3;
		if((g_Platform[i].o_mx-c_pos)>0.02)g_Anim[g_Platform[i].a_nmb].c_Frame=0;
		if((g_Platform[i].o_mx-c_pos)<-0.02)g_Anim[g_Platform[i].a_nmb].c_Frame=4;

		g_Platform[i].o_mx=c_pos;

		g_Anim[g_Platform[i].a_nmb].x=g_Platform[i].x+g_Platform[i].a_ox;
		g_Anim[g_Platform[i].a_nmb].y=g_Platform[i].y+g_Platform[i].a_oy;
	}
}

// ==================================================

/*
 ====================================================
 // Particles
 ====================================================
*/

void particle_AddSystem(int count,float time,float x,float y,float r,float g,float b){
	float r_Angle;

	for(int i=0;i<count;i++){
		g_Particle[c_Particles+i].x=x;
		g_Particle[c_Particles+i].y=y;

		r_Angle=rand();
		g_Particle[c_Particles+i].vx=sin(r_Angle);
		g_Particle[c_Particles+i].vy=cos(r_Angle);

		g_Particle[c_Particles+i].r=r;
		g_Particle[c_Particles+i].g=g;
		g_Particle[c_Particles+i].b=b;
		g_Particle[c_Particles+i].a=1.0;

		g_Particle[c_Particles+i].mt_Life=time;
	}

	c_Particles+=count;
}

// ==================================================


void particle_UpdateParticles(){
	for(int i=0;i<c_Particles;i++){
		g_Particle[i].ct_Life+=10*m_Game.d_Time;
		g_Particle[i].a-=(float)(10/g_Particle[i].mt_Life*m_Game.d_Time);

		if(g_Particle[i].ct_Life>g_Particle[i].mt_Life){
			for(int j=i;j<c_Particles;j++)
				g_Particle[j]=g_Particle[j+1];

			c_Particles--;
		}

		g_Particle[i].x+=g_Particle[i].vx*m_Game.d_Time/2;
		g_Particle[i].y+=g_Particle[i].vy*m_Game.d_Time/2;

		// Cool effect ricochet play-poly
		if(g_Particle[i].x>1||g_Particle[i].x<-1)g_Particle[i].vx*=-1;
		if(g_Particle[i].y>0.85||g_Particle[i].y<-1)g_Particle[i].vy*=-1;
	}
}

// ==================================================

void particle_RenderParticles(){
	glDisable(GL_TEXTURE_2D);

	glEnable(GL_POINT_SMOOTH);
	glPointSize(3);

	glBegin(GL_POINTS);
		for(int i=0;i<c_Particles;i++){
			glColor4f(g_Particle[i].r,g_Particle[i].g,g_Particle[i].b,g_Particle[i].a);
			glVertex2f(g_Particle[i].x,g_Particle[i].y);
		}
	glEnd();

	glDisable(GL_POINT_SMOOTH);
	glEnable(GL_TEXTURE_2D);
}

// ==================================================

/*
 ====================================================
 // Sounds
 ====================================================
*/

void sound_InitOpenAL(){
	m_Game.pDevice=alcOpenDevice(NULL);
	m_Game.pContext=alcCreateContext(m_Game.pDevice,NULL);
	alcMakeContextCurrent(m_Game.pContext);
}

// ==================================================

void sound_LoadWave(char *name){
	int format;
	void *data;
	unsigned int size;
	unsigned int freq;
	char loop;

	alGenBuffers(1,&g_Buffer[c_Buffers]);
	alutLoadWAVFile(name,&format,&data,&size,&freq,&loop);
	alBufferData(g_Buffer[c_Buffers],format,data,size,freq);
	alutUnloadWAV(format,data,size,freq);

	alGenSources(1,&g_BSource[c_Buffers]);
	alSourcei(g_BSource[c_Buffers],AL_BUFFER,g_Buffer[c_Buffers]);

	c_Buffers++;
}

// ==================================================

void sound_Play(int nmb,float x,float y){
	alSourcePlay(g_BSource[nmb]);
}

// ==================================================

void sound_Stop(int nmb){
	alSourceStop(g_BSource[nmb]);
}

// ==================================================

/*
 ====================================================
 // Menu
 ====================================================
*/

void menu_AddItem(float x,float y,float width,float height,float r,float g,float b,float a,float o_textx,float o_texty,char *text){
	g_Item[c_Items].x=x;
	g_Item[c_Items].y=y;
	g_Item[c_Items].width=width;
	g_Item[c_Items].height=height;
	g_Item[c_Items].r=r;
	g_Item[c_Items].g=g;
	g_Item[c_Items].b=b;
	g_Item[c_Items].a=a;
	g_Item[c_Items].o_textx=o_textx;
	g_Item[c_Items].o_texty=o_texty;

	for(int i=0;i<strlen(text);i++)
		g_Item[c_Items].text[i]=text[i];

	c_Items++;
}

// ==================================================

void menu_DeleteItem(int nmb){
	for(int i=nmb;i<c_Items;i++)
		g_Item[i]=g_Item[i+1];

	c_Items--;
}

// ==================================================

void menu_TestPress(){
	if(g_Item[3].sel&&m_Game.lbtn){
		SaveScores();
		PostQuitMessage(0);
	}

	if(g_Item[0].sel&&m_Game.lbtn){
		NewGame();
		m_Game.cur_Level=0;
		m_Game.p_Win=false;
		LoadLevel(g_LevelName[0]);
	}

	if(g_Item[2].sel&&m_Game.lbtn)
		if(m_Game.mi_Scores==false){
			m_Game.mi_Scores=true;
			if(m_Game.mi_Credits)
				menu_DeleteItem(c_Items-1);
			m_Game.mi_Credits=false;

			menu_AddItem(0,0,1,1,1,0,0,0.5,0,0,"");
		}

	if(g_Item[1].sel&&m_Game.lbtn)
		if(m_Game.mi_Credits==false){
			m_Game.mi_Credits=true;
			if(m_Game.mi_Scores)
				menu_DeleteItem(c_Items-1);
			m_Game.mi_Scores=false;

			menu_AddItem(0,0,1,1,1,0,0,0.5,0,0,"");
		}

	if(g_Item[4].sel&&m_Game.lbtn){
		m_Game.mi_Credits=false;
		m_Game.mi_Scores=false;
		menu_DeleteItem(c_Items-1);
	}
}

// ==================================================

void menu_DrawMenu(){
	int i;

	for(i=0;i<c_Items;i++){
		g_Item[i].sel=false;
	}

	for(i=0;i<c_Items;i++){
		if(-1+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f)>g_Item[i].x-g_Item[i].width/2.0f&&
		   -1+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f)<g_Item[i].x+g_Item[i].width/2.0f&&
		   1-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f)>g_Item[i].y-g_Item[i].height/2.0f&&
		   1-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f)<g_Item[i].y+g_Item[i].height/2.0f)g_Item[i].sel=true;
	}

	glDisable(GL_BLEND);

	texture_CallTexture(9);
	glColor4f(1,1,1,1);
	glBegin(GL_QUADS);
		glTexCoord2d(0,0);
		glVertex2f(-1,-1);
		glTexCoord2d(0,1);
		glVertex2f(-1,1);
		glTexCoord2d(1,1);
		glVertex2f(1,1);
		glTexCoord2d(1,0);
		glVertex2f(1,-1);
	glEnd();

	glEnable(GL_BLEND);

	glDisable(GL_TEXTURE_2D);

	glLineWidth(3);
	for(i=0;i<c_Items;i++){
		glBegin(GL_QUADS);
			if(g_Item[i].sel==false)
				glColor4f(g_Item[i].r,g_Item[i].g,g_Item[i].b,g_Item[i].a/2);
			else
				glColor4f(g_Item[i].r,g_Item[i].g,g_Item[i].b,g_Item[i].a);

			glVertex2f(g_Item[i].x-g_Item[i].width/2,
				       g_Item[i].y-g_Item[i].height/2);
			glVertex2f(g_Item[i].x-g_Item[i].width/2,
				       g_Item[i].y+g_Item[i].height/2);
			glVertex2f(g_Item[i].x+g_Item[i].width/2,
				       g_Item[i].y+g_Item[i].height/2);
			glVertex2f(g_Item[i].x+g_Item[i].width/2,
				       g_Item[i].y-g_Item[i].height/2);
		glEnd();

		glBegin(GL_LINE_LOOP);
			if(g_Item[i].sel==false)
				glColor4f(g_Item[i].r,g_Item[i].g,g_Item[i].b,g_Item[i].a);
			else
				glColor4f(g_Item[i].r,g_Item[i].g,g_Item[i].b,g_Item[i].a*2);

			glVertex2f(g_Item[i].x-g_Item[i].width/2,
				       g_Item[i].y-g_Item[i].height/2);
			glVertex2f(g_Item[i].x-g_Item[i].width/2,
				       g_Item[i].y+g_Item[i].height/2);
			glVertex2f(g_Item[i].x+g_Item[i].width/2,
				       g_Item[i].y+g_Item[i].height/2);
			glVertex2f(g_Item[i].x+g_Item[i].width/2,
				       g_Item[i].y-g_Item[i].height/2);
		glEnd();

		ArkPrintf(1,g_Item[i].x+g_Item[i].o_textx,g_Item[i].y+g_Item[i].o_texty,g_Item[i].text);
		
		if(m_Game.mi_Scores){
			glColor4f(1,0,0,1);
			ArkPrintf(0,-0.125,0.35,"Scores : ");
			ArkPrintf(0,-0.45,0.25,"All count scores : ");
			ArkPrintf(0,0.25,0.25,"%d",m_Game.g_FileScores);
			ArkPrintf(0,-0.45,0.2,"All destroy bricks : ");
			ArkPrintf(0,0.25,0.2,"%d",m_Game.g_FileBricks);
		}

		if(m_Game.mi_Credits){
			glColor4f(1,0,0,1);
			ArkPrintf(0,-0.125,0.35,"Credits : ");
			ArkPrintf(0,-0.45,0.25,"Main programmer : ");
			ArkPrintf(0,-0.35,0.20,"faceH0r");
			ArkPrintf(0,-0.45,0.10,"3D/2D & Sound effects : ");
			ArkPrintf(0,-0.35,0.05,"faceH0r");
			ArkPrintf(0,-0.45,-0.05,"Level design : ");
			ArkPrintf(0,-0.35,-0.10,"faceH0r");
			ArkPrintf(0,-0.35,-0.15,"jnz");
		}
	}
	glLineWidth(1);

	glColor4f(0.5,0.5,0.5,1);
	ArkPrintf(1,-0.95,0.9,"Created by faceH0r 11.05.2005");

	glEnable(GL_TEXTURE_2D);

	texture_CallTexture(2);
	glColor3f(1,1,1);
	glBegin(GL_QUADS);
		glTexCoord2d(0,0);
		glVertex2f(-1.05+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f),
			1.05-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f));

		glTexCoord2d(0,1);
		glVertex2f(-1.05+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f),
			0.95-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f));

		glTexCoord2d(1.0/24.0,1);
		glVertex2f(-0.95+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f),
			0.95-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f));

		glTexCoord2d(1.0/24.0,0);
		glVertex2f(-0.95+m_Game.g_Mpos.x/(m_Game.dm.dmPelsWidth/2.0f),
			1.05-m_Game.g_Mpos.y/(m_Game.dm.dmPelsHeight/2.0f));
	glEnd();

	menu_TestPress();
}

// ==================================================

/*
 ====================================================
 // Bonus
 ====================================================
*/

void bonus_AddBonus(float x,float y,float width,float height,int type){
	g_Bonus[c_Bonuses].x=x;
	g_Bonus[c_Bonuses].y=y;
	g_Bonus[c_Bonuses].width=width;
	g_Bonus[c_Bonuses].height=height;
	g_Bonus[c_Bonuses].type=type;

	switch(type){
	case 0:
		g_Bonus[c_Bonuses].t_nmb=6;
		break;
	case 1:
		g_Bonus[c_Bonuses].t_nmb=7;
		break;
	}

	c_Bonuses++;
}

// ==================================================

void bonus_UpdateBonuses(){
	int i;

	for(i=0;i<c_Bonuses;i++)
		g_Bonus[i].y-=0.5*m_Game.d_Time;

	for(i=0;i<c_Bonuses;i++){
		texture_CallTexture(g_Bonus[i].t_nmb);
		glBegin(GL_QUADS);
			glTexCoord2d(0,0);
			glVertex2f(g_Bonus[i].x-g_Bonus[i].width/2,g_Bonus[i].y-g_Bonus[i].height/2);
			glTexCoord2d(0,1);
			glVertex2f(g_Bonus[i].x-g_Bonus[i].width/2,g_Bonus[i].y+g_Bonus[i].height/2);
			glTexCoord2d(1,1);
			glVertex2f(g_Bonus[i].x+g_Bonus[i].width/2,g_Bonus[i].y+g_Bonus[i].height/2);
			glTexCoord2d(1,0);
			glVertex2f(g_Bonus[i].x+g_Bonus[i].width/2,g_Bonus[i].y-g_Bonus[i].height/2);
		glEnd();
	}

	for(i=0;i<c_Bonuses;i++)
		if(g_Bonus[i].y<-0.8&&
		   g_Bonus[i].x>=g_Platform[0].x-g_Platform[0].width/2&&
		   g_Bonus[i].x<=g_Platform[0].x+g_Platform[0].width/2)
		{
			switch(g_Bonus[i].type){
			case 0:
				g_Sphere[i].velocity-=0.5;
				m_Game.g_Scores+=10;
				m_Game.g_SubScores+=10;
				m_Game.g_FileScores+=10;

				if(g_Sphere[i].velocity<0.5)
					g_Sphere[i].velocity=0.5;

				sound_Play(3,0,0);
				bonus_DeleteBonus(i);
				break;
			case 1:
				g_Sphere[i].velocity+=0.5;
				m_Game.g_Scores+=10;
				m_Game.g_SubScores+=10;
				m_Game.g_FileScores+=10;

				if(g_Sphere[i].velocity>4)
					g_Sphere[i].velocity=4;

				sound_Play(3,0,0);
				bonus_DeleteBonus(i);
				break;
			}
		}

	for(i=0;i<c_Bonuses;i++)
		if(g_Bonus[i].y<-1)bonus_DeleteBonus(i);
}

// ==================================================

void bonus_DeleteBonus(int nmb){
	for(int i=nmb;i<c_Bonuses;i++)
		g_Bonus[i]=g_Bonus[i+1];
	
	c_Bonuses--;
}

// ==================================================

void CalculateCountRealBricks(){
	m_Game.c_BricksReal=0;

	for(int i=0;i<c_Bricks;i++)
		if(g_Brick[i].type==0||g_Brick[i].type==1)
			m_Game.c_BricksReal++;
}

// ==================================================

void NewGame(){
	int i;

	m_Game.g_Menu=false;
	m_Game.g_Start=false;
	m_Game.g_Scores=0;
	m_Game.g_SubScores=0;
	m_Game.c_Lives=3;

	for(i=0;i<c_Spheres;i++)
		memset(&g_Sphere[i],0,sizeof(S_ARK_SPHERE_2D));
	c_Spheres=0;

	for(i=0;i<c_Platforms;i++)
		memset(&g_Platform[i],0,sizeof(S_ARK_PLATFORM_2D));
	c_Platforms=0;

	for(i=0;i<c_Bonuses;i++)
		memset(&g_Bonus[i],0,sizeof(S_ARK_BONUS_2D));
	c_Bonuses=0;

	for(i=0;i<c_Bricks;i++)
		memset(&g_Brick[i],0,sizeof(S_ARK_BRICK_2D));
	c_Bricks=0;

	for(i=0;i<c_Anims;i++)
		memset(&g_Anim[i],0,sizeof(S_ARK_ANIMATION_2D));
	c_Anims=0;

	for(i=0;i<c_Lines;i++)
		memset(&g_Line[i],0,sizeof(S_ARK_LINE_2D));
	c_Lines=0;

	for(i=0;i<c_Particles;i++)
		memset(&g_Particle[i],0,sizeof(S_ARK_PARTICLE_2D));
	c_Particles=0;
}

// ==================================================

/* 
 ====================================================
 // Test object in Arkanoid
 ====================================================
*/

void TestObjectLines(S_ARK_SPHERE_2D &obj){
	struct S_ARK_FILL_POINT_2D{
		int c_Cross;	// Count all cross
		int n_Cross[32];	// Numbers line cross
		float r_Cross[32];	// Radiuses cross
		S_ARK_POINT_2D f_Point[32];	// Point crosses
		int min_rNumber;	// Number min radius
	};
	//

	int i,p;
	S_ARK_LINE_2D ln1;
	S_ARK_POINT_2D lcp;
	S_ARK_FILL_POINT_2D sp[8];
	int min_rAll=0;
	int n_Object;
	bool y_Iteration=true;
	float svx,svy;
	//

	if(m_Game.g_Start){
		svx=obj.vx*obj.velocity*100;
		svy=obj.vy*obj.velocity*100;
	}else{
		svx=0;
		svy=0;
	}

	svx*=(m_Game.d_Time);
	svy*=(m_Game.d_Time);

	// Clear array points
	for(p=0;p<8;p++)
		memset(&sp[p],0,sizeof(S_ARK_FILL_POINT_2D));

	for(p=0;p<8;p++){
		// Test cross lines
		for(i=0;i<c_Lines;i++){
				ln1.x1=obj.p[p].x;
				ln1.x2=obj.p[p].x+svx;
				ln1.y1=obj.p[p].y;
				ln1.y2=obj.p[p].y+svy;

				if(CrossLines(ln1,g_Line[i],lcp)){
					sp[p].n_Cross[sp[p].c_Cross]=i;
					sp[p].f_Point[sp[p].c_Cross]=lcp;

					sp[p].c_Cross++;
				}
		}

		if(sp[p].c_Cross!=0){
			// Calculate radiuses
			for(i=0;i<sp[p].c_Cross;i++)
				sp[p].r_Cross[i]=sqrt((obj.p[p].x-sp[p].f_Point[i].x)*(obj.p[p].x-sp[p].f_Point[i].x)+
							          (obj.p[p].y-sp[p].f_Point[i].y)*(obj.p[p].y-sp[p].f_Point[i].y));

			// Calculate minimum radius for all points
			for(i=0;i<sp[p].c_Cross;i++)
				if(sp[p].r_Cross[sp[p].min_rNumber]>sp[p].r_Cross[i])
					sp[p].min_rNumber=i;
		}
	}

	// Calculate min radius of all points
	for(p=0;p<8;p++)
		if(sp[p].c_Cross!=0)
			min_rAll=p;

	// Change volocities
	if(sp[min_rAll].c_Cross!=0){
		particle_AddSystem(5,5,sp[min_rAll].f_Point[sp[min_rAll].min_rNumber].x,sp[min_rAll].f_Point[sp[min_rAll].min_rNumber].y,1,1,1);

		float alpha;

		obj.velocity+=0.005;
		if(obj.velocity>4)obj.velocity=4;
		if(obj.velocity<0.5)obj.velocity=0.5;

		if(sp[min_rAll].n_Cross[sp[min_rAll].min_rNumber]!=g_Platform[0].l_nmb[0]){
		if(g_Line[sp[min_rAll].n_Cross[sp[min_rAll].min_rNumber]].y1==g_Line[sp[min_rAll].n_Cross[sp[min_rAll].min_rNumber]].y2){
			obj.vy*=-1;
			y_Iteration=false;
		}else{
			obj.vx*=-1;
			y_Iteration=false;
		}
		}else{
			alpha=((obj.x-g_Platform[0].x)*2/0.2);

			obj.vx=sin(alpha)*0.01;
			obj.vy=cos(alpha)*0.01;
		}

		// CRASH BRICKS
		n_Object=brick_GetObjectByLine(sp[min_rAll].n_Cross[sp[min_rAll].min_rNumber]);
		if(n_Object!=-1){
			if(g_Brick[n_Object].type!=2){
				sound_Play(2,g_Brick[n_Object].x,g_Brick[n_Object].y);
				g_Brick[n_Object].health--;
				g_Anim[g_Brick[n_Object].a_nmb].c_Frame++;
				m_Game.g_Scores++;
				m_Game.g_SubScores++;
				m_Game.g_FileScores++;
			}else{
				sound_Play(1,g_Brick[n_Object].x,g_Brick[n_Object].y);
			}

			if(g_Brick[n_Object].health<1){
				sound_Play(0,g_Brick[n_Object].x,g_Brick[n_Object].y);

				m_Game.g_Scores+=4;
				m_Game.g_SubScores+=4;
				m_Game.g_FileBricks++;
				m_Game.g_FileScores+=4;
				animation_AddAnimation(8,8,1,g_Brick[n_Object].x,g_Brick[n_Object].y,0.18,0.08,true,true);
				particle_AddSystem(25,25,g_Brick[n_Object].x,g_Brick[n_Object].y,0.85,0.7,0);
				if(rand()%8==1)bonus_AddBonus(g_Brick[n_Object].x,g_Brick[n_Object].y,0.075,0.075,rand()%2);
				
				brick_DelBrick(n_Object);
			}
		}else{
			sound_Play(1,g_Brick[n_Object].x,g_Brick[n_Object].y);
		}
	}

	// End all
	if(y_Iteration&&m_Game.p_Win==false){
		obj.x+=svx;
		obj.y+=svy;
	}

	for(p=0;p<8;p++){
		if(obj.p[p].x>1)obj.x=0.95;
		if(obj.p[p].x<-1)obj.x=-0.95;
		if(obj.p[p].y>0.85)obj.y=0.8;
	}

	if(obj.y<-1){
		obj.y=-0.85;
		obj.x=g_Platform[0].x;
		obj.vx=cos(1.57)*0.01;
		obj.vy=sin(1.57)*0.01;
		obj.velocity=0.5;

		m_Game.c_Lives--;
		m_Game.g_Start=false;

		switch(rand()%2){
		case 0:
			sound_Play(4,0,0);
			break;
		case 1:
			sound_Play(5,0,0);
			break;
		}
		
		if(m_Game.c_Lives<0){
			NewGame();
			m_Game.cur_Level=0;
			m_Game.p_Win=false;
			m_Game.g_Menu=true;

			LoadLevel(g_LevelName[m_Game.cur_Level]);
		}
	}

	if(m_Game.g_SubScores>=1000){
		m_Game.g_SubScores=0;
		m_Game.c_Lives++;
	}
}

// ==================================================

/*
 ====================================================
 // Cross two lines
 // Algorithm jnz & faceH0r
 ====================================================
*/

bool CrossLines(S_ARK_LINE_2D ln1,S_ARK_LINE_2D ln2,S_ARK_POINT_2D &pnt){
	float d1,d10;
	float d2,d20;
	float xp,yp;
	float rx1,rx2,ry1,ry2;
	//
	float tmp;

	rx1=(ln1.x2-ln1.x1);
	rx2=(ln2.x2-ln2.x1);
	ry1=(ln1.y2-ln1.y1);
	ry2=(ln2.y2-ln2.y1);

	d1=(ln1.y2-ln1.y1)/rx1;
	d10=d1*ln1.x1-ln1.y1;
	d2=(ln2.y2-ln2.y1)/rx2;
	d20=d2*ln2.x1-ln2.y1;

	if(rx1==0)xp=ln1.x1;
	if(rx2==0)xp=ln2.x1;
	if(ry1==0)yp=ln1.y1;
	if(ry2==0)yp=ln2.y1;
	
	if(rx1!=0&&rx2!=0)xp=(d20-d10)/(d2-d1);
	if(ry1!=0&&ry2!=0)yp=xp*d1-d10;

	if(ln1.x1>ln1.x2){
		tmp=ln1.x2;
		ln1.x2=ln1.x1;
		ln1.x1=tmp;
	}

	if(ln1.y1>ln1.y2){
		tmp=ln1.y2;
		ln1.y2=ln1.y1;
		ln1.y1=tmp;
	}

	if(ln2.x1>ln2.x2){
		tmp=ln2.x2;
		ln2.x2=ln2.x1;
		ln2.x1=tmp;
	}

	if(ln2.y1>ln2.y2){
		tmp=ln2.y2;
		ln2.y2=ln2.y1;
		ln2.y1=tmp;
	}

	if(xp>=ln2.x1&&xp<=ln2.x2&&xp>=ln1.x1&&xp<=ln1.x2&&
	   yp>=ln1.y1&&yp<=ln1.y2&&yp>=ln2.y1&&yp<=ln2.y2){
			pnt.x=xp;
			pnt.y=yp;

	 		return true;
		}
	else 
		return false;
}

// =====================================================

// =====================================================
// Must die
// Down
// =====================================================

CBACKGROUND g_Background;

// Follow heads
LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevIntanse,LPSTR lpCmdLine,int nShowCmd);
void TestKeys();
void SetDCPixelFormat(HDC hDc);
void InitPixel(HWND hWnd);
void RenderScene();

// =============================================

void TestWin(){
	if(m_Game.c_BricksReal<=0){
		if(m_Game.p_Win==false){
			m_Game.cur_Level++;

			switch(rand()%2){
			case 0:
				sound_Play(6,0,0);
				break;
			case 1:
				sound_Play(7,0,0);
				break;
			}
		}

		m_Game.p_Win=true;
	}else
		m_Game.p_Win=false;
}

// =============================================

void LoadLevel(char *fname){
	FILE *infile;
	char s_name[256];
	int i,count;
	//

	float ff[4];
	int ii[4];
	//

	infile=fopen(fname,"r");
	if(infile!=0){
		fscanf(infile,"%d",&count);
		for(i=0;i<count;i++){
			fscanf(infile,"%f %f %d %d",&ff[0],&ff[1],&ii[0],&ii[1]);
			brick_AddBrick(ff[0],ff[1],ii[0],ii[1]);
		}

		brick_SetRandomVelocity();

		sphere_AddSphere((m_Game.g_Mpos.x-m_Game.dm.dmPelsWidth/2.0f)/((m_Game.dm.dmPelsWidth/2.0f)*1.17f),-0.85,1.57,0.5,0,0);
		platform_AddPlatform(-0.5,0,0.25,0.1,0,-0.08);

		line_AddLine(-1,-1,-1,1);
		line_AddLine(1,1,1,-1);
		line_AddLine(1,0.85,-1,0.85);

		fclose(infile);
	}else{
		sprintf(s_name,fname);
		MessageBox(0,s_name,"File not found",MB_OK);
		PostQuitMessage(0);
	}
}

/*
 ==============================================
 // Text out in the game
 ==============================================
*/

void ArkPrintf(int nmb,float xf,float yf,char *str,...){
	char text[256];
	va_list ap;

	va_start(ap,str);
		vsprintf(text,str,ap);
	va_end(ap);

	glRasterPos2f(xf,yf);
	glListBase(m_Game.t_Base[nmb]-32);
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
}

// =============================================

void ArkBuildFont(int width,int height){
	HFONT fnt;

	m_Game.t_Base[c_Fonts]=glGenLists(96);

	fnt=CreateFont(width,height,0,0,FW_BOLD,0,0,0,0,0,0,0,0,"Courier New");

	SelectObject(m_Game.hDc,fnt);
	wglUseFontBitmaps(m_Game.hDc,32,96,m_Game.t_Base[c_Fonts]);

	c_Fonts++;
}

// ==============================================

void spaceplastic_NewGame(int scores,int lives){
	m_Game.g_Scores=scores;
	m_Game.c_Lives=lives;
}

// ==============================================

void LoadVideo(char *name){
	FILE *infile;
	int ii[4];

	infile=fopen(name,"r");
	if(infile!=0){
		memset(&m_Game.dm,0,sizeof(DEVMODE));
		m_Game.dm.dmSize=sizeof(DEVMODE);
		
		fscanf(infile,"%d %d %d %d",&ii[0],&ii[1],&ii[2],&ii[3]);
		
		if((ii[1]!=1280&&ii[1]!=1024&&ii[1]!=800&&ii[1]!=640&&ii[1]!=320)||
		   (ii[2]!=1024&&ii[2]!=768&&ii[2]!=600&&ii[2]!=480&&ii[2]!=240))
		{
			MessageBox(0,"Video mode is not correct!","Error",MB_OK);
			ExitProcess(0);
		}

		m_Game.dm.dmBitsPerPel=ii[0];
		m_Game.dm.dmPelsWidth=ii[1];
		m_Game.dm.dmPelsHeight=ii[2];
		
		m_Game.dm.dmFields=DM_PELSWIDTH|DM_PELSHEIGHT|DM_BITSPERPEL;
		if(ii[3])ChangeDisplaySettings(&m_Game.dm,CDS_FULLSCREEN);

		fclose(infile);
	}else{
		MessageBox(0,"Video.ini not found","Error",MB_OK);
		PostQuitMessage(0);
	}
}

// ==============================================

void SaveScores(){
	FILE *outfile;

	outfile=fopen("Scores.ini","w");
		fprintf(outfile,"%d %d",m_Game.g_FileScores,m_Game.g_FileBricks);
	fclose(outfile);
}

// ==============================================

void LoadScores(){
	FILE *infile;
	int ii[4];

	infile=fopen("Scores.ini","r");

	if(infile!=0){
		fscanf(infile,"%d %d",&ii[0],&ii[1]);

		m_Game.g_FileScores=ii[0];
		m_Game.g_FileBricks=ii[1];

		fclose(infile);
	}else
		MessageBox(0,"Not file Scores.ini","Error",MB_OK);
}

// ==============================================

// ==============================================

void LoadSetting(char *name){
	FILE *infile;
	int c_tex=0,i,j;
	char str[256];

	infile=fopen(name,"r");
	if(infile!=0){
		// Load textures

		fscanf(infile,"%d",&c_tex);

		for(i=0;i<c_tex;i++){
			fscanf(infile,"%s",&str);
			texture_AddTexture(str);
		}

		// Load sounds
		fscanf(infile,"%d",&c_tex);

		for(i=0;i<c_tex;i++){
			fscanf(infile,"%s",&str);
			sound_LoadWave(str);
		}

		// Load levels names

		fscanf(infile,"%d",&c_tex);
	
		if(c_tex>10){
			c_tex=10;
		}

		c_Levels=c_tex;

		for(i=0;i<c_Levels;i++){
			fscanf(infile,"%s",&str);

			j=0;

			while(str[j]!=0){
				g_LevelName[i][j]=str[j];

				j++;
			}
		}

		fclose(infile);
	}else{
		MessageBox(0,"File Setting.ini not found","Error",MB_OK);
		PostQuitMessage(0);
	}
}

// ==============================================

void InitPixel(HWND hWnd){
	m_Game.hDc=GetDC(hWnd);
	SetDCPixelFormat(m_Game.hDc);
	m_Game.hRc=wglCreateContext(m_Game.hDc);

	//line_CalculateNormals();
}

void SetDCPixelFormat(HDC hDc){
	int nPixelFormat;
	PIXELFORMATDESCRIPTOR pfd;

	memset(&pfd,0,sizeof(pfd));
	pfd.dwFlags=PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER;
	nPixelFormat=ChoosePixelFormat(hDc,&pfd);
	SetPixelFormat(hDc,nPixelFormat,&pfd);
}

void TestKeys(){
	if(m_Game.b_Keys[VK_ESCAPE]&&m_Game.t_Menu>=1)
		if(m_Game.g_Menu==false){
			m_Game.g_Menu=true;
			m_Game.t_Menu=0;
			m_Game.m_Mpos=m_Game.g_Mpos;
		}else{
			m_Game.g_Menu=false;
			m_Game.t_Menu=0;
			SetCursorPos(m_Game.m_Mpos.x,m_Game.m_Mpos.y);

			if(m_Game.mi_Credits||m_Game.mi_Scores){
				menu_DeleteItem(c_Items-1);
				m_Game.mi_Credits=false;
				m_Game.mi_Scores=false;
			}
		}

	m_Game.t_Menu+=0.05;

	GetCursorPos(&m_Game.g_Mpos);
}

void Render(){
	int i;

	glClear(GL_COLOR_BUFFER_BIT);
		TestKeys();

		g_Background.Render();

		glColor3f(1,1,1);

		for(i=0;i<c_Spheres;i++)
			TestObjectLines(g_Sphere[i]);

		sphere_UpdateSpheres();
		brick_MoveBricks();

		platform_UpdatePlatforms();

		animation_UpdateAnimation();
		animation_RenderAnimation();

		// Debug
//		glDisable(GL_TEXTURE_2D);
//			line_RenderLines();
//		glEnable(GL_TEXTURE_2D);

		bonus_UpdateBonuses();

		particle_UpdateParticles();
		particle_RenderParticles();

		CalculateCountRealBricks();

		glDisable(GL_TEXTURE_2D);
			glColor4f(1,0,0,0.5);
			ArkPrintf(0,-0.925,0.9125,"Scores : %d",m_Game.g_Scores);
			glColor4f(0,1,0,0.5);
			ArkPrintf(0,0.4,0.9125,"Bricks left : %d",m_Game.c_BricksReal);
			glColor4f(1,1,1,0.5);
			ArkPrintf(0,-0.3,0.9125,"Count lives : %d",m_Game.c_Lives);
		glEnable(GL_TEXTURE_2D);

		if(m_Game.g_Start==false){
			g_Sphere[0].x=g_Platform[0].x;
			g_Sphere[0].y=g_Platform[0].y+0.025;
		}

		if(m_Game.g_Menu)
			menu_DrawMenu();
		else
			TestWin();

	SwapBuffers(m_Game.hDc);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	char name[256];
	int i=0;

	switch(uMsg){
	case WM_LBUTTONDOWN:
		if(m_Game.g_Menu==false)
			m_Game.g_Start=true;

		m_Game.lbtn=true;

		if(m_Game.p_Win&&m_Game.g_Menu==false){
			if(m_Game.cur_Level>c_Levels-1){
				m_Game.cur_Level=0;
				m_Game.g_Menu=true;
				m_Game.p_Win=false;

				NewGame();
			}

			m_Game.g_Start=false;

			for(i=0;i<c_Spheres;i++)
				memset(&g_Sphere[i],0,sizeof(S_ARK_SPHERE_2D));
			c_Spheres=0;

			for(i=0;i<c_Platforms;i++)
				memset(&g_Platform[i],0,sizeof(S_ARK_PLATFORM_2D));
			c_Platforms=0;

			for(i=0;i<c_Bonuses;i++)
				memset(&g_Bonus[i],0,sizeof(S_ARK_BONUS_2D));
			c_Bonuses=0;

			for(i=0;i<c_Bricks;i++)
				memset(&g_Brick[i],0,sizeof(S_ARK_BRICK_2D));
			c_Bricks=0;

			for(i=0;i<c_Anims;i++)
				memset(&g_Anim[i],0,sizeof(S_ARK_ANIMATION_2D));
			c_Anims=0;

			for(i=0;i<c_Lines;i++)
				memset(&g_Line[i],0,sizeof(S_ARK_LINE_2D));
			c_Lines=0;

			for(i=0;i<c_Particles;i++)
				memset(&g_Particle[i],0,sizeof(S_ARK_PARTICLE_2D));
			c_Particles=0;

			LoadLevel(g_LevelName[m_Game.cur_Level]);
			m_Game.p_Win=false;
		}
		break;
	case WM_LBUTTONUP:
		m_Game.lbtn=false;
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_KEYDOWN:
		m_Game.b_Keys[wParam]=true;
		break;
	case WM_KEYUP:
		m_Game.b_Keys[wParam]=false;
		break;
	case WM_CREATE:
		InitPixel(hWnd);
		sound_InitOpenAL();

		ShowCursor(false);

		wglMakeCurrent(m_Game.hDc,m_Game.hRc);

		LoadSetting("Setting.ini");
		LoadScores();

		LoadLevel("Levels/Level_01.lvl");
		spaceplastic_NewGame(0,3);

		// Create items menu
		menu_AddItem(-0.7125,-0.35,0.35,0.15,1,1,1,0.45,-0.135,-0.0125,"New game");
		menu_AddItem(-0.235,-0.8,0.35,0.15,1,1,1,0.45,-0.1125,-0.0135,"Credits");
		menu_AddItem(0.275,-0.8,0.35,0.15,1,1,1,0.45,-0.105,-0.0125,"Scores");
		menu_AddItem(0.7125,-0.35,0.35,0.15,1,1,1,0.45,-0.075,-0.0125,"Exit");

		m_Game.g_Menu=true;

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

		switch(m_Game.dm.dmPelsWidth){
		case 1280:
			ArkBuildFont(24,21);
			ArkBuildFont(28,21);
			break;
		case 1024:
			ArkBuildFont(20,18);
			ArkBuildFont(25,18);
			break;
		case 800:
			ArkBuildFont(17,14);
			ArkBuildFont(18,14);
			break;
		case 640:
			ArkBuildFont(15,12);
			ArkBuildFont(17,12);
			break;
		case 320:
			ArkBuildFont(11,6);
			ArkBuildFont(14,6);
			break;
		}

		g_Background.TextureGenerated();
		break;
	default:
		return DefWindowProc(hWnd,uMsg,wParam,lParam);
		break;
	}
}

WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevIntanse,LPSTR lpCmdLine,int nShowCmd){
	WNDCLASS wc;
	HWND hWnd;
	MSG msg;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.lpszClassName="SClassSPlastic";
	wc.lpfnWndProc=WndProc;

	RegisterClass(&wc);

	LoadVideo("Video.ini");

	hWnd=CreateWindow("SClassSPlastic","Space-Plastic",WS_POPUP,0,0,m_Game.dm.dmPelsWidth,m_Game.dm.dmPelsHeight,0,0,0,0);

	ShowWindow(hWnd,SW_SHOW);

	m_Game.o_Time=timeGetTime();

	while(msg.message!=WM_QUIT){
		if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}else{
			m_Game.c_Time=timeGetTime();

			if(m_Game.g_Menu==false)
				m_Game.d_Time=(m_Game.c_Time-m_Game.o_Time)*0.001;
			else 
				m_Game.d_Time=0;

			m_Game.o_Time=m_Game.c_Time;
		
			Render();
		}
	}

	return 0;
}