/*
 *###################################################
 * File struct, type and class the game
 * Code by faceH0r 9.05.2005
 *###################################################
 */

#ifndef _ARK_NEEDS_H
#define _ARK_NEEDS_H 

/*
 ====================================================
 // Start code
 ====================================================
*/

// ==================================================
// Constants
// ==================================================

#define ARK_MAX_BRICKS 256
#define ARK_MAX_LINES 1024
#define ARK_MAX_ANIMATIONS 1024
#define ARK_MAX_TEXTURES 64
#define ARK_MAX_SPHERES 64
#define ARK_MAX_PLATFORMS 4
#define ARK_MAX_PARTICLES 1024
#define ARK_MAX_SOUND_BUFFERS 12
#define ARK_MAX_ITEMS 32
#define ARK_MAX_BONUSES 32
#define ARK_MAX_LEVELS 16

// ==================================================
// Struct main game
// ==================================================

struct S_ARK_GAME{
	bool b_Keys[256];
	HGLRC hRc;
	HDC hDc;
	POINT g_Mpos;
	POINT o_Mpos;
	POINT m_Mpos;
	//

	bool g_Start;
	bool g_Menu;
	bool lbtn;
	bool mi_Scores,mi_Credits;
	bool p_Win;
	float t_Menu;
	//

	int t_Base[8];
	float c_Time,o_Time,d_Time;
	int c_BricksReal;
	//

	int g_Scores;
	int g_SubScores;
	//

	int g_FileScores;
	int g_FileBricks;
	//

	int c_Lives;
	int cur_Level;
	//

	ALCdevice *pDevice;
	ALCcontext *pContext;
	DEVMODE dm;
};

// ==================================================
// Structs
// ==================================================

struct S_ARK_ITEM_2D{
	float x,y;
	float width,height;
	float o_textx,o_texty;
	//

	float r,g,b,a;
	//

	char text[256];
	//

	bool sel;
};

// ==================================================

struct S_ARK_POINT_2D{
	float x,y;
};

// ==================================================

struct S_ARK_PARTICLE_2D{
	float x,y;
	float vx,vy;
	//

	float ct_Life;
	float mt_Life;
	//

	float r,g,b,a;
};

// ==================================================

struct S_ARK_LINE_2D{
	float x1,y1,x2,y2;
	//

	float nx,ny;
	//

	float xp,yp;
	//

	bool cross;
};

// ==================================================

struct S_ARK_SPHERE_2D{
	float x,y;
	float vx,vy;
	float velocity;
	//

	float r,b,g;
	//

	int nmb_Anim;
	float a_ox,a_oy;
	//

	S_ARK_POINT_2D p[32];
};

// ==================================================

struct S_ARK_BRICK_2D{
	float x,y;
	//

	float o_x,o_y;
	float vo_x,vo_y;
	//

	int l_nmb[4];
	//

	int health;
	//

	int a_nmb;
	int type;
};

// ==================================================

struct S_ARK_ANIMATION_2D{
	float x,y;
	float o_x,o_y;
	float width,height;
	//

	int c_Frames;
	float t_BFrames;
	//

	int c_Frame;
	float t_CFrame;
	//

	int nmb_Texture;
	//

	int a_Play;
	int a_One; 
};

// ==================================================

struct S_ARK_PLATFORM_2D{
	float x,y;
	float width,height;
	//

	int l_nmb[5];
	//

	float a_ox,a_oy;
	int a_nmb;
	//

	float o_mx,o_my;
};

// ==================================================

struct S_ARK_BONUS_2D{
	float x,y;
	float width,height;
	//

	int t_nmb;
	int type;
};

// ==================================================

#endif