/*
// Special file for class CBACKGROUND
// Last update 7.04.05
// Autor faceH0r
*/

#ifndef _F_CBACKGROUND_H
#define _F_CBACKGROUND_H

// Special constants

#define ARK_BCKG_COUNTBIGSTAR 50
#define ARK_BCKG_COUNTSMALLSTAR 500
//
#define ARK_BCKG_HEIGHT 384
#define ARK_BCKG_WIDTH 384

// It is class

class CBACKGROUND{
public:
	// Identifier textures bacground
	GLuint i_Texture;

	// Point to array data texture
	char *a_Tex;

	// Start CBACKGROUND
	CBACKGROUND(){
		a_Tex=new char[ARK_BCKG_HEIGHT*ARK_BCKG_WIDTH*3];
	}

	// End CBACKGROUND
	~CBACKGROUND(){
		delete a_Tex;
	}

	// One pixel array
	void PutSmallStar(int x,int y,char r,char g,char b,char *&mas){
		mas[(y*3)*ARK_BCKG_WIDTH+x*3]=r;
		mas[(y*3)*ARK_BCKG_WIDTH+x*3+1]=g;
		mas[(y*3)*ARK_BCKG_WIDTH+x*3+2]=b;
	}

	// More pixel array
	void PutBigStar(int x,int y,char r,char g,char b,char *&mas){
		PutSmallStar(x,y,r,g,b,mas);
		PutSmallStar(x-1,y,r,g,b,mas);
		PutSmallStar(x+1,y,r,g,b,mas);
		PutSmallStar(x,y+1,r,g,b,mas);
		PutSmallStar(x,y-1,r,g,b,mas);
	}

	// Setting texture
	void TextureGenerated(){
		int i;
		// Special r,g,b
		char r,g,b;

		// Always marasmus
		srand(GetTickCount());

		// Clear array data
		memset(a_Tex,0,ARK_BCKG_HEIGHT*ARK_BCKG_WIDTH*3);

		// Random generated big stars
		for(i=0;i<ARK_BCKG_COUNTBIGSTAR;i++){
			r=g=b=100+(rand()*105)/32768;
			PutBigStar(2+(rand()*ARK_BCKG_WIDTH-3)/32768,2+(rand()*ARK_BCKG_HEIGHT-3)/32768,r,g,b,a_Tex);
		}

		//Random generated small star
		for(i=0;i<ARK_BCKG_COUNTSMALLSTAR;i++){
			r=g=b=100+(rand()*105)/32768;
			PutSmallStar(2+(rand()*ARK_BCKG_WIDTH-3)/32768,2+(rand()*ARK_BCKG_HEIGHT-3)/32768,r,g,b,a_Tex);
		}

		// Setting texture
		glGenTextures(1,&i_Texture);
		glBindTexture(GL_TEXTURE_2D,i_Texture);

		// No need
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);

		// Create 2d texture mipmap
		gluBuild2DMipmaps(GL_TEXTURE_2D,3,ARK_BCKG_WIDTH,ARK_BCKG_HEIGHT,GL_RGB,GL_UNSIGNED_BYTE,a_Tex);
	}

	// Render background
	void Render(){
		glColor3f(1,1,1);
		glEnable(GL_BLEND);
	    glBindTexture(GL_TEXTURE_2D,i_Texture);
		glBegin(GL_QUADS);
			glTexCoord2d(0,0);
			glVertex2f(-1,-1);
			glTexCoord2d(0,1);
			glVertex2f(-1,1);
			glTexCoord2d(1,1);
			glVertex2f(1,1);
			glTexCoord2d(1,0);
			glVertex2f(1,-1);
		glEnd();
		glDisable(GL_TEXTURE_2D);
		glColor4f(0.5,0.25,0,0.25);
		glBegin(GL_QUADS);
			glTexCoord2d(0,0);
			glVertex2f(-1,0.85);
			glTexCoord2d(0,1);
			glVertex2f(-1,1);
			glTexCoord2d(1,1);
			glVertex2f(1,1);
			glTexCoord2d(1,0);
			glVertex2f(1,0.85);
		glEnd();
		glLineWidth(5);
		glBegin(GL_LINE_LOOP);
			glVertex2f(-1,0.85);
			glVertex2f(-1,0.99);
			glVertex2f(1,0.99);
			glVertex2f(1,0.85);
		glEnd();
		glLineWidth(1);
		glEnable(GL_TEXTURE_2D);
	}

private:
};

//

#endif